// 002 u_08_interface_inheritance
// 18 sep 2010

// -- (C) John COLIBRI 2010
// -- documentation: http://www.jcolibri.com

(*$r+*)
unit u_08_interface_inheritance;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    PageControl1: TPageControl;
    display_: TTabSheet;
    memo_: TTabSheet;
    Panel2: TPanel;
    Memo1: TMemo;
    exit_: TButton;
    clear_: TButton;
    memo_panel_: TPanel;
    Splitter1: TSplitter;
    b_direct_: TButton;
    a_and_b_: TButton;
    a_plus_b_: TButton;
    procedure FormCreate(Sender: TObject);
    procedure close_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure b_direct_Click(Sender: TObject);
    procedure a_and_b_Click(Sender: TObject);
    procedure a_plus_b_Click(Sender: TObject);
  private
  public
  end;

    var Form1: TForm1;

  implementation
    uses u_c_log, u_c_display

       ;

    {$R *.DFM}

    // -- tForm1

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
      end; // FormCreate

    procedure TForm1.close_Click(Sender: TObject);
      begin
        Close;
      end; // close_Click

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    // -- interfaces

    type i_a=
              Interface
                procedure a;
              end; // i_one
         i_b=
              Interface(i_a)
                procedure b;
              end; // i_two
         c__b_direct=
              Class(tInterfacedObject, i_b)
                procedure a;
                procedure b;
              end; // c_class
         c__a_and_b=
              Class(tInterfacedObject, i_a, i_b)
                procedure a;
                procedure b;
              end; // c_class
         c__a=
              Class(tInterfacedObject, i_a)
                procedure a;
              end; // c_class
         c__a_plus_b=
              Class(c__a, i_b)
                procedure a;
                procedure b;
              end; // c_class

    procedure c__b_direct.a;
      begin
      end;

    procedure c__b_direct.b;
      begin
      end;

    procedure c__a_and_b.a;
      begin
      end;

    procedure c__a_and_b.b;
      begin
      end;

    procedure c__a.a;
      begin
      end;

    procedure c__a_plus_b.a;
      begin
      end;

    procedure c__a_plus_b.b;
      begin
      end;

    procedure TForm1.b_direct_Click(Sender: TObject);
      var l_i_a: i_a;
      begin
        // NO l_i_a:= c__b_direct.create;
      end;

    procedure TForm1.a_and_b_Click(Sender: TObject);
      var l_i_a: i_a;
      begin
        l_i_a:= c__a_and_b.create;
      end; // a_and_b_Click

    procedure TForm1.a_plus_b_Click(Sender: TObject);
      var l_i_a: i_a;
      begin
        l_i_a:= c__a_plus_b.create;
      end; // a_plus_bClick

end.


